## rtipc 1.0.3.g0a8e332

=== CMakeLists.txt ===
#############################################################################
#
#  Copyright 2012 Richard Hacker (lerichi at gmx dot net)
#
#  This is the main cmake file for the rtipc package
#
#  The following options can be specified on the command line of cmake to
#  change the installation paths (Defaults are in <>)
#       -DCMAKE_INSTALL_PREFIX=</usr/local>
#       -DCMAKE_INSTALL_INCLUDEDIR=<${CMAKE_INSTALL_PREFIX}/include>
#       -DCMAKE_INSTALL_LIBDIR=<${CMAKE_INSTALL_PREFIX}/lib(64)>
#       -DCMAKE_INSTALL_LOCALSTATEDIR=<${CMAKE_INSTALL_PREFIX}/var>
#
#  For debugging, use the
#       -DCMAKE_BUILD_TYPE=Debug|Release|RelWithDebInfo|MinSizeRel
#  option
#
#  This file is part of the rtipc package.
#
#  rtipc is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  rtipc is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with rtipc. See COPYING. If not, see
#  <http://www.gnu.org/licenses/>.
#
#############################################################################

CMAKE_MINIMUM_REQUIRED (VERSION 3.2...4.0)

PROJECT (rtipc VERSION 1.0.3)

#
# Release Instructions
#
# - Make sure new symbols are listed in src/librtipc.map
# - Update the version history in README.md
# - Update version numbers above (semantic versioning)
# - Update SOVERSION below on ABI breakage
#

# Library version
SET (SOVERSION 1)

# GNU Paths:
#       CMAKE_INSTALL_*
INCLUDE (GNUInstallDirs)

# Length of source path to leave it out in log messages
string(LENGTH "${PROJECT_SOURCE_DIR}/src/" SRC_PATH_LENGTH)

LIST (APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules/")
FIND_PACKAGE (Yaml REQUIRED)
FIND_PACKAGE (Mhash REQUIRED)

ADD_SUBDIRECTORY (src)
ADD_SUBDIRECTORY (test)

INSTALL (DIRECTORY include/
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
    FILES_MATCHING PATTERN "*.h")

# Directory where RTIPC stores its variable cache files
SET (VARDIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/${PROJECT_NAME}")
INSTALL (CODE "FILE(MAKE_DIRECTORY \"\$ENV{DESTDIR}${VARDIR}\")")

CONFIGURE_FILE (
    "${PROJECT_SOURCE_DIR}/config.h.in"
    "${PROJECT_BINARY_DIR}/config.h"
    )

=== src/CMakeLists.txt ===
#############################################################################
#
#  Copyright 2012 Richard Hacker (lerichi at gmx dot net)
#
#  This file is part of the rtipc library.
#
#  The rtipc library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or (at your
#  option) any later version.
#
#  The rtipc library is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
#  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
#  License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with the rtipc library. If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################


SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

ADD_LIBRARY( ${PROJECT_NAME} SHARED
    Group.cpp Group.h
    Main.cpp Main.h
    Debug.cpp Debug.h
    RxPdo.cpp RxPdo.h

    BulletinBoard/Group.cpp BulletinBoard/Group.h
    BulletinBoard/Flock.cpp BulletinBoard/Flock.h
    BulletinBoard/Main.cpp BulletinBoard/Main.h
    BulletinBoard/YamlDoc.cpp BulletinBoard/YamlDoc.h
    BulletinBoard/DataType.cpp BulletinBoard/DataType.h
    BulletinBoard/Semaphore.cpp BulletinBoard/Semaphore.h
    BulletinBoard/Signal.cpp BulletinBoard/Signal.h
    )

SET_TARGET_PROPERTIES ( ${PROJECT_NAME} PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION "${SOVERSION}"
    CLEAN_DIRECT_OUTPUT 1
    CXX_VISIBILITY_PRESET "hidden"
    VISIBILITY_INLINES_HIDDEN 1

)
SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES LINK_FLAGS " -Wl,-version-script=${CMAKE_CURRENT_SOURCE_DIR}/librtipc.map")

ADD_CUSTOM_TARGET(symbol_version_check COMMAND
    /bin/sh "${CMAKE_CURRENT_SOURCE_DIR}/check_symbol_versions.sh" $<TARGET_FILE:${PROJECT_NAME}>
)

ADD_DEPENDENCIES(symbol_version_check ${PROJECT_NAME})
SET_SOURCE_FILES_PROPERTIES(Main.cpp PROPERTIES
    OBJECT_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/librtipc.map"
)



TARGET_LINK_LIBRARIES (${PROJECT_NAME} PRIVATE
    ${Yaml_LIBRARIES}
    ${Mhash_LIBRARY}
)
TARGET_INCLUDE_DIRECTORIES (${PROJECT_NAME} PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>"
    "$<INSTALL_INTERFACE:include>"
)
TARGET_INCLUDE_DIRECTORIES (${PROJECT_NAME} PRIVATE
    ${Yaml_INCLUDE_DIR}
    ${Mhash_INCLUDE_DIR}
    "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>"
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>"
)

# prepare version information

IF(VERSION_HASH)
    # Hash was given as option, so write it directly
    # useful for OBS packaging
    FILE(WRITE "${CMAKE_CURRENT_BINARY_DIR}/git_revision_hash.h"
        "#define GIT_REV \"${VERSION_HASH}\"
")
ELSE()
    # recompute hash on every `make` invocation
    # Note: CMake variable definitions (-D) must be before the -P option!
    ADD_CUSTOM_TARGET(GitRevision
        BYPRODUCTS "${CMAKE_CURRENT_BINARY_DIR}/git_revision_hash.h"
        COMMAND ${CMAKE_COMMAND}
            -DSOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}/.."
            -DHASH_MACRO_NAME="GIT_REV"
            -DTARGET_FILE="${CMAKE_CURRENT_BINARY_DIR}/git_revision_hash.h"
            -P ${CMAKE_CURRENT_SOURCE_DIR}/git_revision.cmake
    )
    ADD_DEPENDENCIES(${PROJECT_NAME} GitRevision)
ENDIF()


# pkgconfig files
CONFIGURE_FILE (
    "${CMAKE_CURRENT_SOURCE_DIR}/librtipc.pc.in"
    "${CMAKE_CURRENT_BINARY_DIR}/librtipc.pc" @ONLY
)

INCLUDE (CMakePackageConfigHelpers)
# cmake target export stuff
configure_package_config_file (config.cmake.in
        "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)
write_basic_package_version_file (
        "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
    COMPATIBILITY SameMajorVersion
)
INSTALL (TARGETS ${PROJECT_NAME}
    EXPORT ${PROJECT_NAME}Targets
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)
# cmake target export and pkg-config
INSTALL (FILES
        ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)
INSTALL (EXPORT ${PROJECT_NAME}Targets
    NAMESPACE EtherLab::
    FILE ${PROJECT_NAME}Targets.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)

INSTALL (FILES "${CMAKE_CURRENT_BINARY_DIR}/librtipc.pc"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

EXPORT(EXPORT ${PROJECT_NAME}Targets
    FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake"
    NAMESPACE EtherLab::
)

=== test/CMakeLists.txt ===
##############################################################################
#
#  Copyright 2012 Richard Hacker (lerichi at gmx dot net)
#
#  This file is part of the rtipc library.
#
#  The rtipc library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or (at your
#  option) any later version.
#
#  The rtipc library is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
#  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
#  License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with the rtipc library. If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

ADD_EXECUTABLE(test1 test1.cpp)
TARGET_LINK_LIBRARIES(test1 ${PROJECT_NAME} rt)

ADD_TEST(test1 test1)

=== debian/changelog ===
rtipc (1.0.3.g0a8e332-0+13.1) unstable; urgency=low

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Mon, 28 Jul 2025 16:10:01 +0000

rtipc (1.0.3.g0a8e332-0) unstable; urgency=low

  * Initial release

 -- Andreas Stewering-Bone <andreas.stewering-bone@gmx.de>  Thu, 04 Oct 2018 22:51:02 +0200

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

RTIPC_VERSION=`dpkg-parsechangelog --show-field Version | cut -d - -f 1`

# be strict regarding symbol file
export DPKG_GENSYMBOLS_CHECK_LEVEL := 3

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# main packaging script based on dh7 syntax
%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
^		-DVERSION_HASH=${RTIPC_VERSION}

## rtipc 1.0.4.g21eefa3

=== CMakeLists.txt ===
--- 
+++ 
@@ -35,7 +35,7 @@
 
 CMAKE_MINIMUM_REQUIRED (VERSION 3.2...4.0)
 
-PROJECT (rtipc VERSION 1.0.3)
+PROJECT (rtipc VERSION 1.0.4)
 
 #
 # Release Instructions
@@ -58,7 +58,9 @@
 
 LIST (APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules/")
 FIND_PACKAGE (Yaml REQUIRED)
-FIND_PACKAGE (Mhash REQUIRED)
+
+FIND_PACKAGE (PkgConfig)
+pkg_check_modules(Zlib REQUIRED zlib)
 
 ADD_SUBDIRECTORY (src)
 ADD_SUBDIRECTORY (test)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -60,7 +60,7 @@
 
 TARGET_LINK_LIBRARIES (${PROJECT_NAME} PRIVATE
     ${Yaml_LIBRARIES}
-    ${Mhash_LIBRARY}
+    ${Zlib_LIBRARIES}
 )
 TARGET_INCLUDE_DIRECTORIES (${PROJECT_NAME} PUBLIC
     "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>"
@@ -68,7 +68,7 @@
 )
 TARGET_INCLUDE_DIRECTORIES (${PROJECT_NAME} PRIVATE
     ${Yaml_INCLUDE_DIR}
-    ${Mhash_INCLUDE_DIR}
+    ${Zlib_INCLUDE_DIRS}
     "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>"
     "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>"
 )

=== debian/changelog ===
rtipc (1.0.4.g21eefa3-0+4.1) unstable; urgency=low

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Thu, 06 Nov 2025 09:20:12 +0000

rtipc (1.0.4.g21eefa3-0) unstable; urgency=low

  * Initial release

 -- Andreas Stewering-Bone <andreas.stewering-bone@gmx.de>  Thu, 04 Oct 2018 22:51:02 +0200

rtipc (1.0.4.1) stable; urgency=low

  * Changed from mhash to zlib

 -- Florian Pose <fp@igh.de>  Thu, 06 Nov 2025 09:52:00 +0100

=== debian/control ===
Source: rtipc
Priority: optional
Maintainer: Andreas Stewering-Bone <ab@igh.de>
Build-Depends: debhelper (>= 9), cmake, libyaml-dev, zlib1g-dev
Standards-Version: 3.9.5
Section: libs
Homepage: https://etherlab.org

Package: librtipc-dev
Section: libdevel
Architecture: any
Depends: librtipc1 (= ${binary:Version}), ${misc:Depends}
Description: Realtime IPC Library
 This is a library that allows unrelated processes to exchange variables via
 shared memory.  Typically, this library is used to communicate between
 processes that implement different aspects of a control application.
 .
 An application exports named variables to shared memory. Similarly, it imports
 named variables, which are read from shared memory. If all attributes are
 correct (element count and data type), these are connected and data is
 exchanged. Semaphores protect access to the shared memory areas.
 .
 Header files

Package: librtipc1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Realtime IPC Library
 This is a library that allows unrelated processes to exchange variables via
 shared memory.  Typically, this library is used to communicate between
 processes that implement different aspects of a control application.
 .
 An application exports named variables to shared memory. Similarly, it imports
 named variables, which are read from shared memory. If all attributes are
 correct (element count and data type), these are connected and data is
 exchanged. Semaphores protect access to the shared memory areas.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

RTIPC_VERSION=`dpkg-parsechangelog --show-field Version | cut -d - -f 1`

# be strict regarding symbol file
export DPKG_GENSYMBOLS_CHECK_LEVEL := 3

# main packaging script based on dh7 syntax
%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
		-DVERSION_HASH=${RTIPC_VERSION}
